JUCE: AiffAudioFormat Class Reference

JUCE

Public Member Functions | Static Public Attributes | List of all members
AiffAudioFormat Class Reference

Reads and Writes AIFF format audio files. More...

Inheritance diagram for AiffAudioFormat:

## Public Member Functions
| AiffAudioFormat ()
| Creates an format object. More...
| ~AiffAudioFormat () override
| Destructor. More...
Array< int > | getPossibleSampleRates () override
| Returns a set of sample rates that the format can read and write. More...
Array< int > | getPossibleBitDepths () override
| Returns a set of bit depths that the format can read and write. More...
bool | canDoStereo () override
| Returns true if the format can do 2-channel audio. More...
bool | canDoMono () override
| Returns true if the format can do 1-channel audio. More...
bool | canHandleFile (const File &fileToTest) override
| Returns true if this the given file can be read by this format. More...
AudioFormatReader * | createReaderFor (InputStream *sourceStream, bool deleteStreamIfOpeningFails) override
| Tries to create an object that can read from a stream containing audio data in this format. More...
MemoryMappedAudioFormatReader * | createMemoryMappedReader (const File &) override
| Attempts to create a MemoryMappedAudioFormatReader, if possible for this format. More...
MemoryMappedAudioFormatReader * | createMemoryMappedReader (FileInputStream *) override
AudioFormatWriter * | createWriterFor (OutputStream *streamToWriteTo, double sampleRateToUse, unsigned int numberOfChannels, int bitsPerSample, const StringPairArray &metadataValues, int qualityOptionIndex) override
| Tries to create an object that can write to a stream with this audio format. More...
virtual AudioFormatWriter * | createWriterFor (OutputStream *streamToWriteTo, double sampleRateToUse, unsigned int numberOfChannels, int bitsPerSample, const StringPairArray &metadataValues, int qualityOptionIndex)=0
| Tries to create an object that can write to a stream with this audio format. More...
virtual AudioFormatWriter * | createWriterFor (OutputStream *streamToWriteTo, double sampleRateToUse, const AudioChannelSet &channelLayout, int bitsPerSample, const StringPairArray &metadataValues, int qualityOptionIndex)
| Tries to create an object that can write to a stream with this audio format. More...
Public Member Functions inherited from AudioFormat
virtual | ~AudioFormat ()
| Destructor. More...
const String & | getFormatName () const
| Returns the name of this format. More...
virtual StringArray | getFileExtensions () const
| Returns all the file extensions that might apply to a file of this format. More...
virtual bool | isCompressed ()
| Returns true if the format uses compressed data. More...
virtual bool | isChannelLayoutSupported (const AudioChannelSet &channelSet)
| Returns true if the channel layout is supported by this format. More...
virtual StringArray | getQualityOptions ()
| Returns a list of different qualities that can be used when writing. More...
virtual AudioFormatWriter * | createWriterFor (OutputStream *streamToWriteTo, double sampleRateToUse, const AudioChannelSet &channelLayout, int bitsPerSample, const StringPairArray &metadataValues, int qualityOptionIndex)
| Tries to create an object that can write to a stream with this audio format. More...

## Static Public Attributes
static const char *const | appleOneShot
| Metadata property name used when reading a aiff file with a basc chunk. More...
static const char *const | appleRootSet
| Metadata property name used when reading a aiff file with a basc chunk. More...
static const char *const | appleRootNote
| Metadata property name used when reading a aiff file with a basc chunk. More...
static const char *const | appleBeats
| Metadata property name used when reading a aiff file with a basc chunk. More...
static const char *const | appleDenominator
| Metadata property name used when reading a aiff file with a basc chunk. More...
static const char *const | appleNumerator
| Metadata property name used when reading a aiff file with a basc chunk. More...
static const char *const | appleTag
| Metadata property name used when reading a aiff file with a basc chunk. More...
static const char *const | appleKey
| Metadata property name used when reading a aiff file with a basc chunk. More...

## Additional Inherited Members
Protected Member Functions inherited from AudioFormat
| AudioFormat (String formatName, StringArray fileExtensions)
| Creates an AudioFormat object. More...
| AudioFormat (StringRef formatName, StringRef fileExtensions)
| Creates an AudioFormat object. More...

## Detailed Description

Reads and Writes AIFF format audio files.

See also
  AudioFormat

## Constructor & Destructor Documentation

## ◆ AiffAudioFormat()

AiffAudioFormat::AiffAudioFormat | ( |  | ) |

Creates an format object.

## ◆ ~AiffAudioFormat()

AiffAudioFormat::~AiffAudioFormat | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ getPossibleSampleRates()

Array<int> AiffAudioFormat::getPossibleSampleRates | ( |  | ) |
| overridevirtual

Returns a set of sample rates that the format can read and write.

Implements AudioFormat.

## ◆ getPossibleBitDepths()

Array<int> AiffAudioFormat::getPossibleBitDepths | ( |  | ) |
| overridevirtual

Returns a set of bit depths that the format can read and write.

Implements AudioFormat.

## ◆ canDoStereo()

bool AiffAudioFormat::canDoStereo | ( |  | ) |
| overridevirtual

Returns true if the format can do 2-channel audio.

Implements AudioFormat.

## ◆ canDoMono()

bool AiffAudioFormat::canDoMono | ( |  | ) |
| overridevirtual

Returns true if the format can do 1-channel audio.

Implements AudioFormat.

## ◆ canHandleFile()

bool AiffAudioFormat::canHandleFile | ( | const File & | fileToTest | ) |
| overridevirtual

Returns true if this the given file can be read by this format.

Subclasses shouldn't do too much work here, just check the extension or file type. The base class implementation just checks the file's extension against one of the ones that was registered in the constructor.

Reimplemented from AudioFormat.

## ◆ createReaderFor()

AudioFormatReader* AiffAudioFormat::createReaderFor | ( | InputStream * | sourceStream,
|  | bool | deleteStreamIfOpeningFails
| ) |  |
| overridevirtual

Tries to create an object that can read from a stream containing audio data in this format.

The reader object that is returned can be used to read from the stream, and should then be deleted by the caller.

Parameters

  sourceStream | the stream to read from - the AudioFormatReader object that is returned will delete this stream when it no longer needs it.
  deleteStreamIfOpeningFails | if no reader can be created, this determines whether this method should delete the stream object that was passed-in. (If a valid reader is returned, it will always be in charge of deleting the stream, so this parameter is ignored)

See also
  AudioFormatReader

Implements AudioFormat.

## ◆ createMemoryMappedReader() [1/2]

MemoryMappedAudioFormatReader* AiffAudioFormat::createMemoryMappedReader | ( | const File & | file | ) |
| overridevirtual

Attempts to create a MemoryMappedAudioFormatReader, if possible for this format.

If the format does not support this, the method will return nullptr;

Reimplemented from AudioFormat.

## ◆ createMemoryMappedReader() [2/2]

MemoryMappedAudioFormatReader* AiffAudioFormat::createMemoryMappedReader | ( | FileInputStream * |  | ) |
| overridevirtual

Reimplemented from AudioFormat.

## ◆ createWriterFor() [1/3]

AudioFormatWriter* AiffAudioFormat::createWriterFor | ( | OutputStream * | streamToWriteTo,
|  | double | sampleRateToUse,
|  | unsigned int | numberOfChannels,
|  | int | bitsPerSample,
|  | const StringPairArray & | metadataValues,
|  | int | qualityOptionIndex
| ) |  |
| overridevirtual

Tries to create an object that can write to a stream with this audio format.

The writer object that is returned can be used to write to the stream, and should then be deleted by the caller.

If the stream can't be created for some reason (e.g. the parameters passed in here aren't suitable), this will return nullptr.

Parameters

  streamToWriteTo | the stream that the data will go to - this will be deleted by the AudioFormatWriter object when it's no longer needed. If no AudioFormatWriter can be created by this method, the stream will NOT be deleted, so that the caller can re-use it to try to open a different format, etc
  sampleRateToUse | the sample rate for the file, which must be one of the ones returned by getPossibleSampleRates()
  numberOfChannels | the number of channels - this must be either 1 or 2, and the choice will depend on the results of canDoMono() and canDoStereo()
  bitsPerSample | the bits per sample to use - this must be one of the values returned by getPossibleBitDepths()
  metadataValues | a set of metadata values that the writer should try to write to the stream. Exactly what these are depends on the format, and the subclass doesn't actually have to do anything with them if it doesn't want to. Have a look at the specific format implementation classes to see possible values that can be used
  qualityOptionIndex | the index of one of compression qualities returned by the getQualityOptions() method. If there aren't any quality options for this format, just pass 0 in this parameter, as it'll be ignored

See also
  AudioFormatWriter

Implements AudioFormat.

## ◆ createWriterFor() [2/3]

virtual AudioFormatWriter* AudioFormat::createWriterFor

Tries to create an object that can write to a stream with this audio format.

The writer object that is returned can be used to write to the stream, and should then be deleted by the caller.

If the stream can't be created for some reason (e.g. the parameters passed in here aren't suitable), this will return nullptr.

Parameters

  streamToWriteTo | the stream that the data will go to - this will be deleted by the AudioFormatWriter object when it's no longer needed. If no AudioFormatWriter can be created by this method, the stream will NOT be deleted, so that the caller can re-use it to try to open a different format, etc
  sampleRateToUse | the sample rate for the file, which must be one of the ones returned by getPossibleSampleRates()
  numberOfChannels | the number of channels - this must be either 1 or 2, and the choice will depend on the results of canDoMono() and canDoStereo()
  bitsPerSample | the bits per sample to use - this must be one of the values returned by getPossibleBitDepths()
  metadataValues | a set of metadata values that the writer should try to write to the stream. Exactly what these are depends on the format, and the subclass doesn't actually have to do anything with them if it doesn't want to. Have a look at the specific format implementation classes to see possible values that can be used
  qualityOptionIndex | the index of one of compression qualities returned by the getQualityOptions() method. If there aren't any quality options for this format, just pass 0 in this parameter, as it'll be ignored

See also
  AudioFormatWriter

## ◆ createWriterFor() [3/3]

virtual AudioFormatWriter* AudioFormat::createWriterFor

Tries to create an object that can write to a stream with this audio format.

The writer object that is returned can be used to write to the stream, and should then be deleted by the caller.

If the stream can't be created for some reason (e.g. the parameters passed in here aren't suitable), this will return nullptr.

Parameters

  streamToWriteTo | the stream that the data will go to - this will be deleted by the AudioFormatWriter object when it's no longer needed. If no AudioFormatWriter can be created by this method, the stream will NOT be deleted, so that the caller can re-use it to try to open a different format, etc
  sampleRateToUse | the sample rate for the file, which must be one of the ones returned by getPossibleSampleRates()
  channelLayout | the channel layout for the file. Use isChannelLayoutSupported to check if the writer supports this layout.
  bitsPerSample | the bits per sample to use - this must be one of the values returned by getPossibleBitDepths()
  metadataValues | a set of metadata values that the writer should try to write to the stream. Exactly what these are depends on the format, and the subclass doesn't actually have to do anything with them if it doesn't want to. Have a look at the specific format implementation classes to see possible values that can be used
  qualityOptionIndex | the index of one of compression qualities returned by the getQualityOptions() method. If there aren't any quality options for this format, just pass 0 in this parameter, as it'll be ignored

See also
  AudioFormatWriter

## Member Data Documentation

## ◆ appleOneShot

const char* const AiffAudioFormat::appleOneShot
| static

Metadata property name used when reading a aiff file with a basc chunk.

## ◆ appleRootSet

const char* const AiffAudioFormat::appleRootSet
| static

Metadata property name used when reading a aiff file with a basc chunk.

## ◆ appleRootNote

const char* const AiffAudioFormat::appleRootNote
| static

Metadata property name used when reading a aiff file with a basc chunk.

## ◆ appleBeats

const char* const AiffAudioFormat::appleBeats
| static

Metadata property name used when reading a aiff file with a basc chunk.

## ◆ appleDenominator

const char* const AiffAudioFormat::appleDenominator
| static

Metadata property name used when reading a aiff file with a basc chunk.

## ◆ appleNumerator

const char* const AiffAudioFormat::appleNumerator
| static

Metadata property name used when reading a aiff file with a basc chunk.

## ◆ appleTag

const char* const AiffAudioFormat::appleTag
| static

Metadata property name used when reading a aiff file with a basc chunk.

## ◆ appleKey

const char* const AiffAudioFormat::appleKey
| static

Metadata property name used when reading a aiff file with a basc chunk.

The documentation for this class was generated from the following file:

- juce_AiffAudioFormat.h